LS(1)

NAME
ls - list directory contents

SYNOPSIS
ls [-1AaBbCcdFfghikLlMmnOoPpqRrSsTtuWwXx] [file ...]

DESCRIPTION
For each file operand that names a file of a type other than directory, ls displays its name as well as any requested, associated information. For each file operand that names a file of type directory, ls displays the names of files contained within that directory, as well as any requested, associated information.

If no operands are given, the contents of the current directory are displayed. If more than one operand is given, non-directory operands are displayed first; directory and non-directory operands are sorted separately and in lexicographical order.

The following options are available:

-1  (The numeric digit “one”). Force output to be one entry per line. This is the default when output is not to a terminal.

-A  List all entries except for ‘’. and ‘..’. Always set for the super-user.

-a  Include directory entries whose names begin with a dot (‘’)..

-B  Force printing of non-graphic characters in file names as \xxx, where xxx is the numeric value of the character in octal.

-b  As -B, but use C escape codes whenever possible.

-C  Force multi-column output; this is the default when output is to a terminal.

-c  Use time when file status was last changed, instead of time of last modification of the file for printing (-l) or sorting (-t). Overrides -u.

-d  Directories are listed as plain files (not searched recursively) and symbolic links in the argument list are not followed. Turns off -R if also given.

-F  Display a slash (‘/’) immediately after each pathname that is a directory, an asterisk (‘*’) after each that is executable, an at sign (‘@’) after each symbolic link, a percent sign (‘%’) after each whiteout, an equal sign (‘=’) after each socket, and a vertical bar (‘|’) after each that is a FIFO.

-f  Output is not sorted. This option implies -a.

-g  The same as -l, except that the owner is not printed.

-h  Modifies the -l and -s options, causing the sizes to be reported in bytes displayed in a human readable format. Overrides -k and -M.

-i  For each file, print the file's file serial number (inode number).

-k  Modifies the -s option, causing the sizes to be reported in kilobytes. Overrides -h.

-L  For each file, if it's a link, evaluate file information and file type of the referenced file and not the link itself; however still print the link name, unless used with -l, for example.

-l  (The lowercase letter “ell”). List in long format. (See below.)

-M  Modifies the -l and -s options, causing the sizes or block counts reported to be separated with commas (or a locale appropriate separator) resulting in a more readable output. Overrides -h; does not override -k.

-m  Stream output format; list files across the page, separated by commas.

-n  The same as -l, except that the owner and group IDs are displayed numerically rather than converting to a owner or group name.

-O  Output only leaf files (not directories), eliding other ls output.

-o  Include the file flags in a long (-l) output. If no file flags are set, “-” is displayed. (See chflags(1) for a list of possible flags and their meanings.)

-P  Print the full pathname for each file.

-p  Display a slash (‘/’) immediately after each pathname that is a directory.

-q  Force printing of non-printable characters in file names as the character ‘’?; this is the default when output is to a terminal.

-R  Recursively list subdirectories encountered. See also -d.

-r  Reverse the order of the sort to get reverse lexicographical order or the smallest or oldest entries first.

-S  Sort by size, largest file first.

-s  Display the number of file system blocks actually used by each file, in units of 512 bytes or BLOCKSIZE (see ENVIRONMENT) where partial units are rounded up to the next integer value. If the output is to a terminal, a total sum for all the file sizes is output on a line before the listing.

-T  When used with the -l (the lowercase letter “ell”) option, display complete time information for the file, including month, day, hour, minute, second, and year.

-t  Sort by time modified (most recently modified first) before sorting the operands by lexicographical order.

-u  Use time of last access, instead of last modification of the file for printing (-l) or sorting (-t). Overrides -c.

-W  Display whiteouts when scanning directories.

-w  Force raw printing of non-printable characters. This is the default when output is not to a terminal.

-x  Multi-column output sorted across the page rather than down the page.

-X  Don't cross mount points when recursing.

The -B, -b, -q, and -w options all override each other; the last one specified determines the format used for non-printable characters.

The -1, -C, -g, -l, -m, and -x options all override each other; the last one specified determines the format used with the exception that if both -l and -g are specified, -l will always override -g, even if -g was specified last.

By default, ls lists one entry per line to standard output; the exceptions are to terminals or when the -C or -m options are specified.

File information is displayed with one or more <blank> characters separating the information associated with the -i, -l, and -s options.

  The Long Format
If the -l option is given, the following information is displayed for each file:
file mode
number of links
owner name
group name
file flags (if -o given)
number of bytes in the file
abbreviated month file was last modified
day-of-month file was last modified
hour and minute file was last modified
pathname

In addition, for each directory whose contents are displayed, the total number of file system blocks in units of 512 bytes or BLOCKSIZE (see ENVIRONMENT) used by the files in the directory is displayed on a line by itself immediately before the information for the files in the directory.

If the owner or group names are not a known owner or group name, or the -n option is given, the numeric ID's are displayed.

If the file is a character special or block special file, the major and minor device numbers for the file are displayed in the size field. If the file is a symbolic link the pathname of the linked-to file is preceded by “->”.

The file mode printed under the -l option consists of the entry type, owner permissions, group permissions, and other permissions. The entry type character describes the type of file, as follows:

-   Regular file.
a   Archive state 1.
A   Archive state 2.
b   Block special file.
c   Character special file.
d   Directory.
l   Symbolic link.
p   FIFO.
s   Socket link.
w   Whiteout.

The next three fields are three characters each: owner permissions, group permissions, and other permissions. Each field has three character positions:

1.  If r, the file is readable; if -, it is not readable.

2.  If w, the file is writable; if -, it is not writable.

3.  The first of the following that applies:

    S   If in the owner permissions, the file is not executable and set-user-ID mode is set. If in the group permissions, the file is not executable and set-group-ID mode is set.

    s   If in the owner permissions, the file is executable and set-user-ID mode is set. If in the group permissions, the file is executable and setgroup-ID mode is set.

    x   The file is executable or the directory is searchable.

    -   The file is neither readable, writable, executable, nor set-user-ID nor set-group-ID mode, nor sticky. (See below.)

    These next two apply only to the third character in the last group (other permissions).

    T   The sticky bit is set (mode 1000), but not execute or search permission. (See chmod(1) or sticky(7).)

    t   The sticky bit is set (mode 1000), and is searchable or executable. (See chmod(1) or sticky(7).)

The next field contains a plus (‘+’) character if the file has an ACL, or a space (‘ ’) if it does not. The ls utility does not show the actual ACL; use getfacl(1) to do this.

The number of bytes displayed for a directory is a function of the number of dirent(3) structures in the directory, not all of which may be allocated to any existing file.

ENVIRONMENT
The following environment variables affect the execution of ls:

BLOCKSIZE
    If the environment variable BLOCKSIZE is set, and the -k option is not specified, the block counts (see -l and -s) will be displayed in units of that size block.

COLUMNS
    If this variable contains a string representing a decimal integer, it is used as the column position width for displaying multiple-text-column output. The ls utility calculates how many pathname text columns to display based on the width provided. (See -C.)

TZ  The timezone to use when displaying dates. See environ(7) for more information.

EXIT STATUS

COMPATIBILITY
The group field is now automatically included in the long listing for files in order to be compatible with the p1003.2 specification.

SEE ALSO
chflags(1), chmod(1), stat(2), dirent(3), getbsize(3), sticky(7), symlink(7)

STANDARDS
The ls utility is expected to be a superset of the p1003.2 specification.

HISTORY
An ls utility appeared in AT&T UNIX.